/* Automatically generated nanopb header */
/* Generated by nanopb-0.3.9.3 at Mon May 13 01:04:53 2019. */

#ifndef PB_DEVICE_MESSAGING_DEVICE_V1_OUTBOUND_PB_H_INCLUDED
#define PB_DEVICE_MESSAGING_DEVICE_V1_OUTBOUND_PB_H_INCLUDED
#include <pb.h>

#include "device/messaging/device/v1/common.pb.h"

/* @@protoc_insertion_point(includes) */
#if PB_PROTO_HEADER_VERSION != 30
#error Regenerate this file with the current version of nanopb generator.
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Struct definitions */
typedef struct _device_messaging_device_v1_Pong {
    char dummy_field;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Pong) */
} device_messaging_device_v1_Pong;

typedef struct _device_messaging_device_v1_Subscribe {
    char dummy_field;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Subscribe) */
} device_messaging_device_v1_Subscribe;

typedef struct _device_messaging_device_v1_Auth_DeviceId {
    int32_t manufacturer_id;
    int32_t device_number;
    pb_callback_t tags;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Auth_DeviceId) */
} device_messaging_device_v1_Auth_DeviceId;

typedef struct _device_messaging_device_v1_Auth_RoleDescription {
    pb_callback_t role_name;
    int32_t role_mask;
    char role_pass[32];
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Auth_RoleDescription) */
} device_messaging_device_v1_Auth_RoleDescription;

typedef struct _device_messaging_device_v1_CommandAck {
    device_messaging_device_v1_CommandId command_id;
    bool subscribe;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_CommandAck) */
} device_messaging_device_v1_CommandAck;

typedef struct _device_messaging_device_v1_Event_Command {
    device_messaging_device_v1_CommandId command_id;
    bool ack;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Event_Command) */
} device_messaging_device_v1_Event_Command;

typedef struct _device_messaging_device_v1_Auth {
    device_messaging_device_v1_Auth_DeviceId device_id;
    pb_callback_t roles;
    char secret[32];
    bool subscribe;
    bool force_int32;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Auth) */
} device_messaging_device_v1_Auth;

typedef struct _device_messaging_device_v1_Event_Meta {
    int32_t event_id;
    device_messaging_device_v1_Event_Command command;
    int32_t roles_mask;
    int32_t history_size;
    bool subscribe;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Event_Meta) */
} device_messaging_device_v1_Event_Meta;

typedef struct _device_messaging_device_v1_Event {
    device_messaging_device_v1_Event_Meta meta;
    pb_callback_t type;
    pb_callback_t value;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_Event) */
} device_messaging_device_v1_Event;

typedef struct _device_messaging_device_v1_OutboundV1 {
    pb_size_t which_type;
    union {
        device_messaging_device_v1_Auth auth;
        device_messaging_device_v1_Pong pong;
        device_messaging_device_v1_Subscribe subscribe;
        device_messaging_device_v1_Event event;
        device_messaging_device_v1_CommandAck command_ack;
    } type;
/* @@protoc_insertion_point(struct:device_messaging_device_v1_OutboundV1) */
} device_messaging_device_v1_OutboundV1;

/* Default values for struct fields */

/* Initializer values for message structs */
#define device_messaging_device_v1_OutboundV1_init_default {0, {device_messaging_device_v1_Auth_init_default}}
#define device_messaging_device_v1_Auth_init_default {device_messaging_device_v1_Auth_DeviceId_init_default, {{NULL}, NULL}, "", 0, 0}
#define device_messaging_device_v1_Auth_DeviceId_init_default {0, 0, {{NULL}, NULL}}
#define device_messaging_device_v1_Auth_RoleDescription_init_default {{{NULL}, NULL}, 0, ""}
#define device_messaging_device_v1_Pong_init_default {0}
#define device_messaging_device_v1_Subscribe_init_default {0}
#define device_messaging_device_v1_Event_init_default {device_messaging_device_v1_Event_Meta_init_default, {{NULL}, NULL}, {{NULL}, NULL}}
#define device_messaging_device_v1_Event_Meta_init_default {0, device_messaging_device_v1_Event_Command_init_default, 0, 0, 0}
#define device_messaging_device_v1_Event_Command_init_default {device_messaging_device_v1_CommandId_init_default, 0}
#define device_messaging_device_v1_CommandAck_init_default {device_messaging_device_v1_CommandId_init_default, 0}
#define device_messaging_device_v1_OutboundV1_init_zero {0, {device_messaging_device_v1_Auth_init_zero}}
#define device_messaging_device_v1_Auth_init_zero {device_messaging_device_v1_Auth_DeviceId_init_zero, {{NULL}, NULL}, "", 0, 0}
#define device_messaging_device_v1_Auth_DeviceId_init_zero {0, 0, {{NULL}, NULL}}
#define device_messaging_device_v1_Auth_RoleDescription_init_zero {{{NULL}, NULL}, 0, ""}
#define device_messaging_device_v1_Pong_init_zero {0}
#define device_messaging_device_v1_Subscribe_init_zero {0}
#define device_messaging_device_v1_Event_init_zero {device_messaging_device_v1_Event_Meta_init_zero, {{NULL}, NULL}, {{NULL}, NULL}}
#define device_messaging_device_v1_Event_Meta_init_zero {0, device_messaging_device_v1_Event_Command_init_zero, 0, 0, 0}
#define device_messaging_device_v1_Event_Command_init_zero {device_messaging_device_v1_CommandId_init_zero, 0}
#define device_messaging_device_v1_CommandAck_init_zero {device_messaging_device_v1_CommandId_init_zero, 0}

/* Field tags (for use in manual encoding/decoding) */
#define device_messaging_device_v1_Auth_DeviceId_manufacturer_id_tag 1
#define device_messaging_device_v1_Auth_DeviceId_device_number_tag 2
#define device_messaging_device_v1_Auth_DeviceId_tags_tag 3
#define device_messaging_device_v1_Auth_RoleDescription_role_name_tag 1
#define device_messaging_device_v1_Auth_RoleDescription_role_mask_tag 2
#define device_messaging_device_v1_Auth_RoleDescription_role_pass_tag 3
#define device_messaging_device_v1_CommandAck_command_id_tag 1
#define device_messaging_device_v1_CommandAck_subscribe_tag 2
#define device_messaging_device_v1_Event_Command_command_id_tag 1
#define device_messaging_device_v1_Event_Command_ack_tag 2
#define device_messaging_device_v1_Auth_device_id_tag 1
#define device_messaging_device_v1_Auth_roles_tag 2
#define device_messaging_device_v1_Auth_secret_tag 3
#define device_messaging_device_v1_Auth_subscribe_tag 4
#define device_messaging_device_v1_Auth_force_int32_tag 5
#define device_messaging_device_v1_Event_Meta_event_id_tag 1
#define device_messaging_device_v1_Event_Meta_command_tag 2
#define device_messaging_device_v1_Event_Meta_roles_mask_tag 3
#define device_messaging_device_v1_Event_Meta_history_size_tag 4
#define device_messaging_device_v1_Event_Meta_subscribe_tag 5
#define device_messaging_device_v1_Event_meta_tag 1
#define device_messaging_device_v1_Event_type_tag 2
#define device_messaging_device_v1_Event_value_tag 3
#define device_messaging_device_v1_OutboundV1_auth_tag 1
#define device_messaging_device_v1_OutboundV1_pong_tag 2
#define device_messaging_device_v1_OutboundV1_subscribe_tag 3
#define device_messaging_device_v1_OutboundV1_event_tag 4
#define device_messaging_device_v1_OutboundV1_command_ack_tag 5

/* Struct field encoding specification for nanopb */
extern const pb_field_t device_messaging_device_v1_OutboundV1_fields[6];
extern const pb_field_t device_messaging_device_v1_Auth_fields[6];
extern const pb_field_t device_messaging_device_v1_Auth_DeviceId_fields[4];
extern const pb_field_t device_messaging_device_v1_Auth_RoleDescription_fields[4];
extern const pb_field_t device_messaging_device_v1_Pong_fields[1];
extern const pb_field_t device_messaging_device_v1_Subscribe_fields[1];
extern const pb_field_t device_messaging_device_v1_Event_fields[4];
extern const pb_field_t device_messaging_device_v1_Event_Meta_fields[6];
extern const pb_field_t device_messaging_device_v1_Event_Command_fields[3];
extern const pb_field_t device_messaging_device_v1_CommandAck_fields[3];

/* Maximum encoded size of messages (where known) */
/* device_messaging_device_v1_OutboundV1_size depends on runtime parameters */
/* device_messaging_device_v1_Auth_size depends on runtime parameters */
/* device_messaging_device_v1_Auth_DeviceId_size depends on runtime parameters */
/* device_messaging_device_v1_Auth_RoleDescription_size depends on runtime parameters */
#define device_messaging_device_v1_Pong_size     0
#define device_messaging_device_v1_Subscribe_size 0
/* device_messaging_device_v1_Event_size depends on runtime parameters */
#define device_messaging_device_v1_Event_Meta_size 60
#define device_messaging_device_v1_Event_Command_size 23
#define device_messaging_device_v1_CommandAck_size 23

/* Message IDs (where set with "msgid" option) */
#ifdef PB_MSGID

#define OUTBOUND_MESSAGES \


#endif

#ifdef __cplusplus
} /* extern "C" */
#endif
/* @@protoc_insertion_point(eof) */

#endif
